/***************************************************************************
                          log.c  -  log output functions
                             -------------------
    begin                : Mon Sep 29 2003
    copyright            : (C) 2003 by red0x
    email                : red0x@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <syslog.h>
#include "sonar.h"
/*#include "plugin.h"*/
#include "log.h"


extern plugin_list_t output_list[];
extern int num_out;
extern sonar_t mthis;

/** \fn void log_write(int flags, char *msg, ...)
 * Outputs data either to syslog, to console, and/or to plugins
 * \param flags Tells how to output
 * \param msg Format string to output
 */
void log_write(int flags, char *msg, ...)
{
        va_list ap;
        int i;

        va_start(ap, msg);
	
        if(flags & LOG_DBUG)
        {
#ifdef	DEBUG
                fprintf(stderr, "DEBUG: ");
                vfprintf(stderr, msg, ap);
                return;
#endif
        }
        if(flags & LOG_CONSOLE)
        {
                /* if we are forked, or quiet, dont do this */
                if(!mthis.sCon.bFork && mthis.sCon.iVerbose >= 0)
                {
                        /*fprintf(stderr, " "); */
                        vfprintf(stderr, msg, ap);
                }
        }
        if(flags & LOG_SLOG)
        {
                /* only print in syslog if we are forked */
                if(mthis.sCon.bFork)
                {
                        /*openlog("sonar", LOG_PID, LOG_DAEMON);*/
                        vsyslog(LOG_DAEMON | LOG_NOTICE, msg, ap);
                        /*closelog();*/
                }
        }
        if(flags & LOG_PLUGINS)
        {
                for(i = 0; i < num_out; i++)
                {
                        if(output_list[i].plug != NULL)
                                if(output_list[i].plug->selected
                                   && output_list[i].plug->ready)
                                        output_list[i].plug->
                                                plugin_output(msg, &ap);
                }
        }
        va_end(ap);
}
