/***************************************************************************
                          mutex.h  -  contains debuggable mutexes
                             -------------------
    begin                : Tues May 13 2003
    copyright            : (C) 2003 by red0x
    email                : red0x@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/** @file mutex.h
  * File contains debuggable mutexs
  */

#ifndef _MUTEX_H_
#define _MUTEX_H_

#include <pthread.h>

typedef struct
{
        pthread_mutex_t mutex;
        char id[80];
        char *locked_by;
} sonar_mutex_t;

int sonar_mutex_init(sonar_mutex_t * mutex,
                     const pthread_mutexattr_t * mutexattr, char *id);
int sonar_mutex_lock(sonar_mutex_t * mutex, char *who);
int sonar_mutex_unlock(sonar_mutex_t * mutex, char *who);
int sonar_mutex_destroy(sonar_mutex_t * mutex);

#endif
