/***************************************************************************
                          types.h  -  description
                             -------------------
    begin                : Fri Apr 19 2002
    copyright            : (C) 2002 by red0x
    email                : red0x@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/** @file types.h
  * File contains most of the type declarations
  */
#ifndef TYPES_H_
#define TYPES_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#define _GNU_SOURCE 1

#ifndef __USE_BSD
#define __USE_BSD               //for portability
#endif

#ifndef __FAVOR_BSD
#define __FAVOR_BSD             //for portability
#endif

/* Get all the types first */
#include <sys/types.h>
#include <stdio.h>

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#include <signal.h>
#include <stdarg.h>

#ifdef TIME_WITH_SYS_TIME
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif //HAVE_SYS_TIME_H
#include <time.h>
#else
#ifdef TM_IN_SYS_TIME
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif //HAVE_SYS_TIME_H
#else
#include <time.h>
#endif //TM_IN_SYS_TIME
#endif //TIME_WITH_SYS_TIME

/**
  * @struct sa
  * Socket Address
  * This needs to be removed
  */
struct sa
{
    /** Socket Family */
        unsigned short family,
    /** Destination Port */
          dport;
    /** IP Address */
        unsigned int addr;
    /** Padding (zeros) */
        unsigned char zero[8];
};

typedef unsigned short bool;
#define true	1
#define false 	0

#endif
