/***************************************************************************
                          util.h  -  description
                             -------------------
    begin                : Wed Apr 17 2002
    copyright            : (C) 2002 by red0x
    email                : red0x@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTIL_H_
#define UTIL_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "types.h"
#include "plugin.h"

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#include <sys/wait.h>

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifndef INADDR_NONE
#define INADDR_NONE  ((in_addr_t) 0xffffffff)
#endif

/* Define this too high, and output plugins will lose there files */
#define	MAXFD	3	
/* was 64 */

extern FILE *raw_output;
extern int main(int, char **);

/* old functions */
void sonar_usage(const char *err);
void bput(char **dest, const char *src, const int len);
void sonar_commandline(char *argv[], int argc, char **out);
void tvsub(register struct timeval *out, register struct timeval *in);
void sonar_msg(char *msg, ...);
RETSIGTYPE sig_int(int i);
RETSIGTYPE sig_kill(int i);
RETSIGTYPE sig_hup(int i);
RETSIGTYPE sig_segv(int i);
int sonar_setoutput(sonar_t * mthis, char *fname);
struct stat *get_stats(const char *path);
void daemon_proc(const char *pname, int facility);
void escape_shell(char **myfunc);
target_t *randomize(target_t * in);
int insert_results(result_t *results, result_t *insertion);
void free_results(result_t *results);

#endif
